﻿module mdy_udp_ip_example(
      clk           ,
      rst_n         ,
      rx_data     ,
      rx_sop      ,
      rx_eop      ,
      rx_vld      ,
      rx_mty      ,

      phy_reset , 
      gm_rx_clk , 
      gm_rx_d   , 
      gm_rx_dv  , 
      gm_rx_err , 
      gm_tx_clk , 
      gm_tx_d   , 
      gm_tx_en  , 
      gm_tx_err , 
      mdio      , 
      mdc         


 );

input           clk           ;
input           rst_n         ;



output[15:0]      rx_data     ;
output            rx_sop      ;
output            rx_eop      ;
output            rx_vld      ;
output            rx_mty      ;

output            phy_reset ; 
input             gm_rx_clk ; 
input [7:0]       gm_rx_d   ; 
input             gm_rx_dv  ; 
input             gm_rx_err ; 
output reg [7:0]       gm_tx_d   ; 
output  reg          gm_tx_en  ; 
output            gm_tx_err ; 
output            gm_tx_clk ; 
inout             mdio      ; 
output            mdc       ; 


reg    [7:0]      cnt;
wire              add_cnt;
wire              end_cnt;
reg    [26:0]     cnt0;
wire              add_cnt0;
wire              end_cnt0;
reg      flag;


wire clk_100m;
wire clk_125m;
wire  [575:0]  data;





my_pll u_my_pll(
	.inclk0(clk     ),
	.c0    (clk_100m),
	.c1    (clk_125m) );






assign data =//720'h555555555555555d5ffffffffffff2c200450000000000000000008004500003021b300004011d5a6c0a8010ac0a8010ac0a801090bb81288001c57b8efec3dd6c53644673921bc646db397c882b55041; 
              {
                64'h5555_5555_5555_55d5, 
                48'hffff_ffff_ffff,      //目的MAC   
                48'h2c02_0304_0507,      //源MAC
                16'h0806,         //帧类型          固定值   

                16'h0001,         //硬件类型        固定值
                16'h0800,         //协议类型        固定值
                8'h06,            //硬件地址长度    固定值  整合为一个16位
                8'h04,            //协议地址长度    固定值  整合为一个16位
                16'h0001,         //请求包文为1，应答包文为2
                48'h2c02_0304_0507,      //源MAC
                {8'd192 , 8'd168 , 8'd1 , 8'd10},//源IP地址
                48'h0,          //目的MAC
                {8'd192 , 8'd168 , 8'd1 , 8'd9},//目的IP地址



                144'h0000_0000_0000_0000,//数据

                //CRC-32计算器算出来的是
                //9BAABFA4  不包含前导码
                //需要调转，实际是 A4_BF_AA_9B

                32'hA4_BF_AA_9B//校验码
               };

assign gm_tx_err = 0;
assign gm_tx_clk = ~clk_125m;
assign mdio = 1;
assign phy_reset = 1;
assign gm_tx_err = 0;

always @(posedge clk_125m or negedge rst_n)begin
    if(!rst_n)begin
        cnt0 <= 0;
    end
    else if(add_cnt0)begin
        if(end_cnt0)
            cnt0 <= 0;
        else
            cnt0 <= cnt0 + 1;
    end
end

assign add_cnt0 = 1;       
assign end_cnt0 = add_cnt0 && cnt0== 50000072-1;   

always  @(posedge clk_125m or negedge rst_n)begin
    if(rst_n==1'b0)begin
        gm_tx_d  <= 0;
        gm_tx_en <= 0;
    end
    else if(cnt0<72)begin
       gm_tx_d  <= data[(576-cnt0*8)-1 -:8];// 8'hff；
        gm_tx_en <= 1;
    end
    else begin
        gm_tx_d  <= 0;
        gm_tx_en <= 0;
    end
end





endmodule
